"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var redux_1 = require("redux");
var react_redux_1 = require("react-redux");
var commons_1 = require("../../utils/commons");
var get_legend_items_1 = require("../../state/selectors/get_legend_items");
var get_settings_specs_1 = require("../../state/selectors/get_settings_specs");
var get_chart_theme_1 = require("../../state/selectors/get_chart_theme");
var get_legend_items_values_1 = require("../../state/selectors/get_legend_items_values");
var get_legend_size_1 = require("../../state/selectors/get_legend_size");
var legend_1 = require("../../state/actions/legend");
var light_theme_1 = require("../../utils/themes/light_theme");
var legend_2 = require("../../state/actions/legend");
var colors_1 = require("../../state/actions/colors");
var style_utils_1 = require("./style_utils");
var legend_item_1 = require("./legend_item");
var get_internal_is_intialized_1 = require("../../state/selectors/get_internal_is_intialized");
var LegendComponent = (function (_super) {
    __extends(LegendComponent, _super);
    function LegendComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LegendComponent.prototype.render = function () {
        var _a = this.props, items = _a.items, position = _a.position, size = _a.size, debug = _a.debug, _b = _a.chartTheme, chartMargins = _b.chartMargins, legend = _b.legend;
        if (items.length === 0) {
            return null;
        }
        var legendContainerStyle = style_utils_1.getLegendStyle(position, size);
        var legendListStyle = style_utils_1.getLegendListStyle(position, chartMargins, legend);
        var legendClasses = classnames_1.default('echLegend', "echLegend--" + position, {
            'echLegend--debug': debug,
        });
        var itemProps = {
            position: position,
            totalItems: items.length,
            extraValues: this.props.extraValues,
            showExtra: this.props.showExtra,
            onMouseOut: this.props.onItemOut,
            onMouseOver: this.props.onItemOver,
            onClick: this.props.onItemClick,
            clearTemporaryColorsAction: this.props.clearTemporaryColors,
            setPersistedColorAction: this.props.setPersistedColor,
            setTemporaryColorAction: this.props.setTemporaryColor,
            mouseOutAction: this.props.onItemOutAction,
            mouseOverAction: this.props.onItemOverAction,
            toggleDeselectSeriesAction: this.props.onToggleDeselectSeriesAction,
            colorPicker: this.props.colorPicker,
        };
        return (react_1.default.createElement("div", { className: legendClasses },
            react_1.default.createElement("div", { style: legendContainerStyle, className: "echLegendListContainer" },
                react_1.default.createElement("ul", { style: legendListStyle, className: "echLegendList" }, items.map(function (item, index) {
                    return legend_item_1.renderLegendItem(item, itemProps, items.length, index);
                })))));
    };
    LegendComponent.displayName = 'Legend';
    return LegendComponent;
}(react_1.default.Component));
exports.LegendComponent = LegendComponent;
var mapDispatchToProps = function (dispatch) {
    return redux_1.bindActionCreators({
        onToggle: legend_1.onToggleLegend,
        onToggleDeselectSeriesAction: legend_2.onToggleDeselectSeriesAction,
        onItemOutAction: legend_2.onLegendItemOutAction,
        onItemOverAction: legend_2.onLegendItemOverAction,
        clearTemporaryColors: colors_1.clearTemporaryColors,
        setTemporaryColor: colors_1.setTemporaryColor,
        setPersistedColor: colors_1.setPersistedColor,
    }, dispatch);
};
var EMPTY_DEFAULT_STATE = {
    items: [],
    position: commons_1.Position.Right,
    collapsed: false,
    extraValues: new Map(),
    debug: false,
    chartTheme: light_theme_1.LIGHT_THEME,
    size: { width: 0, height: 0 },
    showExtra: false,
};
var mapStateToProps = function (state) {
    if (!get_internal_is_intialized_1.getInternalIsInitializedSelector(state)) {
        return EMPTY_DEFAULT_STATE;
    }
    var _a = get_settings_specs_1.getSettingsSpecSelector(state), legendPosition = _a.legendPosition, showLegend = _a.showLegend, showLegendExtra = _a.showLegendExtra, debug = _a.debug, legendColorPicker = _a.legendColorPicker, onItemOver = _a.onLegendItemOver, onItemOut = _a.onLegendItemOut, onItemClick = _a.onLegendItemClick;
    if (!showLegend) {
        return EMPTY_DEFAULT_STATE;
    }
    return {
        debug: debug,
        chartTheme: get_chart_theme_1.getChartThemeSelector(state),
        size: get_legend_size_1.getLegendSizeSelector(state),
        collapsed: state.interactions.legendCollapsed,
        items: get_legend_items_1.getLegendItemsSelector(state),
        position: legendPosition,
        showExtra: showLegendExtra,
        extraValues: get_legend_items_values_1.getLegendExtraValuesSelector(state),
        colorPicker: legendColorPicker,
        onItemOver: onItemOver,
        onItemOut: onItemOut,
        onItemClick: onItemClick,
    };
};
exports.Legend = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(LegendComponent);
//# sourceMappingURL=legend.js.map