"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var TooltipComponent = react_1.forwardRef(function (_a, ref) {
    var info = _a.info, headerFormatter = _a.headerFormatter;
    var renderHeader = react_1.useCallback(function (headerData, formatter) {
        if (!headerData || !headerData.isVisible) {
            return null;
        }
        return react_1.default.createElement("div", { className: "echTooltip__header" }, formatter ? formatter(headerData) : headerData.value);
    }, [info.header, headerFormatter]);
    return (react_1.default.createElement("div", { className: "echTooltip", ref: ref },
        renderHeader(info.header, headerFormatter),
        react_1.default.createElement("div", { className: "echTooltip__list" }, info.values.map(function (_a, index) {
            var seriesIdentifier = _a.seriesIdentifier, valueAccessor = _a.valueAccessor, label = _a.label, value = _a.value, markValue = _a.markValue, color = _a.color, isHighlighted = _a.isHighlighted, isVisible = _a.isVisible;
            if (!isVisible) {
                return null;
            }
            var classes = classnames_1.default('echTooltip__item', {
                echTooltip__rowHighlighted: isHighlighted,
            });
            return (react_1.default.createElement("div", { key: seriesIdentifier.key + "__" + valueAccessor + "__" + index, className: classes, style: {
                    borderLeftColor: color,
                } },
                react_1.default.createElement("span", { className: "echTooltip__label" }, label),
                react_1.default.createElement("span", { className: "echTooltip__value" }, value),
                markValue && react_1.default.createElement("span", { className: "echTooltip__markValue" },
                    "\u00A0(",
                    markValue,
                    ")")));
        }))));
});
exports.Tooltip = react_1.memo(TooltipComponent);
//# sourceMappingURL=tooltip.js.map