"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_dom_1 = require("react-dom");
var react_redux_1 = require("react-redux");
var utils_1 = require("./utils");
var get_internal_is_tooltip_visible_1 = require("../../state/selectors/get_internal_is_tooltip_visible");
var get_tooltip_header_formatter_1 = require("../../state/selectors/get_tooltip_header_formatter");
var get_internal_tooltip_info_1 = require("../../state/selectors/get_internal_tooltip_info");
var get_internal_tooltip_anchor_position_1 = require("../../state/selectors/get_internal_tooltip_anchor_position");
var tooltip_1 = require("./tooltip");
var get_internal_is_intialized_1 = require("../../state/selectors/get_internal_is_intialized");
var TooltipPortalComponent = (function (_super) {
    __extends(TooltipPortalComponent, _super);
    function TooltipPortalComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.portalNode = null;
        _this.tooltipRef = react_1.default.createRef();
        return _this;
    }
    TooltipPortalComponent.prototype.createPortalNode = function () {
        var container = document.getElementById('echTooltipContainerPortal');
        if (container) {
            this.portalNode = container;
        }
        else {
            this.portalNode = document.createElement('div');
            this.portalNode.id = 'echTooltipContainerPortal';
            this.portalNode.style.width = TooltipPortalComponent.MAX_WIDTH + "px";
            document.body.appendChild(this.portalNode);
        }
    };
    TooltipPortalComponent.prototype.componentDidMount = function () {
        this.createPortalNode();
    };
    TooltipPortalComponent.prototype.componentDidUpdate = function () {
        this.createPortalNode();
        var _a = this.props, getChartContainerRef = _a.getChartContainerRef, position = _a.position;
        var chartContainerRef = getChartContainerRef();
        if (!this.tooltipRef.current || !chartContainerRef.current || !this.portalNode || !position) {
            return;
        }
        var chartContainerBBox = chartContainerRef.current.getBoundingClientRect();
        var tooltipBBox = this.tooltipRef.current.getBoundingClientRect();
        var width = Math.min(TooltipPortalComponent.MAX_WIDTH, chartContainerBBox.width * 0.7);
        this.portalNode.style.width = width + "px";
        var tooltipStyle = utils_1.getFinalTooltipPosition(chartContainerBBox, tooltipBBox, width, position);
        if (tooltipStyle.left) {
            this.portalNode.style.left = tooltipStyle.left;
            if (this.tooltipRef.current) {
                this.tooltipRef.current.style.left = tooltipStyle.anchor === 'right' ? 'auto' : '0px';
                this.tooltipRef.current.style.right = tooltipStyle.anchor === 'right' ? '0px' : 'auto';
            }
        }
        if (tooltipStyle.top) {
            this.portalNode.style.top = tooltipStyle.top;
        }
    };
    TooltipPortalComponent.prototype.componentWillUnmount = function () {
        if (this.portalNode && this.portalNode.parentNode) {
            this.portalNode.parentNode.removeChild(this.portalNode);
        }
    };
    TooltipPortalComponent.prototype.render = function () {
        var _a = this.props, isVisible = _a.isVisible, info = _a.info, getChartContainerRef = _a.getChartContainerRef;
        var chartContainerRef = getChartContainerRef();
        if (!this.portalNode || chartContainerRef.current === null || !isVisible || !info) {
            return null;
        }
        return react_dom_1.createPortal(react_1.default.createElement(tooltip_1.Tooltip, { info: info, ref: this.tooltipRef, headerFormatter: this.props.headerFormatter }), this.portalNode);
    };
    TooltipPortalComponent.displayName = 'Tooltip';
    TooltipPortalComponent.MAX_WIDTH = 256;
    return TooltipPortalComponent;
}(react_1.default.Component));
var HIDDEN_TOOLTIP_PROPS = {
    isVisible: false,
    info: undefined,
    position: null,
    headerFormatter: undefined,
};
var mapStateToProps = function (state) {
    if (!get_internal_is_intialized_1.getInternalIsInitializedSelector(state)) {
        return HIDDEN_TOOLTIP_PROPS;
    }
    return {
        isVisible: get_internal_is_tooltip_visible_1.getInternalIsTooltipVisibleSelector(state),
        info: get_internal_tooltip_info_1.getInternalTooltipInfoSelector(state),
        position: get_internal_tooltip_anchor_position_1.getInternalTooltipAnchorPositionSelector(state),
        headerFormatter: get_tooltip_header_formatter_1.getTooltipHeaderFormatterSelector(state),
    };
};
exports.TooltipPortal = react_redux_1.connect(mapStateToProps)(TooltipPortalComponent);
//# sourceMappingURL=tooltip_portal.js.map