"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var series_identifiers_1 = require("./series/series_identifiers");
var commons_1 = require("../utils/commons");
var light_theme_1 = require("../utils/themes/light_theme");
var lodash_1 = require("lodash");
var color = 'red';
var barSeriesStyle = light_theme_1.LIGHT_THEME.barSeriesStyle, lineSeriesStyle = light_theme_1.LIGHT_THEME.lineSeriesStyle, areaSeriesStyle = light_theme_1.LIGHT_THEME.areaSeriesStyle, bubbleSeriesStyle = light_theme_1.LIGHT_THEME.bubbleSeriesStyle;
var MockPointGeometry = (function () {
    function MockPointGeometry() {
    }
    MockPointGeometry.default = function (partial) {
        return commons_1.mergePartial(MockPointGeometry.base, partial, { mergeOptionalPartialValues: true });
    };
    MockPointGeometry.fromBaseline = function (baseline, omitKeys) {
        if (omitKeys === void 0) { omitKeys = []; }
        return function (partial) {
            return lodash_1.omit(commons_1.mergePartial(MockPointGeometry.base, partial, { mergeOptionalPartialValues: true }, [baseline]), omitKeys);
        };
    };
    MockPointGeometry.base = {
        x: 0,
        y: 0,
        radius: 0,
        color: color,
        seriesIdentifier: series_identifiers_1.MockSeriesIdentifier.default(),
        styleOverrides: undefined,
        value: {
            accessor: 'y0',
            x: 0,
            y: 0,
            mark: null,
        },
        transform: {
            x: 25,
            y: 0,
        },
    };
    return MockPointGeometry;
}());
exports.MockPointGeometry = MockPointGeometry;
var MockBarGeometry = (function () {
    function MockBarGeometry() {
    }
    MockBarGeometry.default = function (partial) {
        return commons_1.mergePartial(MockBarGeometry.base, partial, { mergeOptionalPartialValues: true });
    };
    MockBarGeometry.fromBaseline = function (baseline, omitKeys) {
        if (omitKeys === void 0) { omitKeys = []; }
        return function (partial) {
            var geo = commons_1.mergePartial(MockBarGeometry.base, partial, { mergeOptionalPartialValues: true }, [
                baseline,
            ]);
            return lodash_1.omit(geo, omitKeys);
        };
    };
    MockBarGeometry.base = {
        x: 0,
        y: 0,
        width: 0,
        height: 0,
        color: color,
        displayValue: {
            text: '',
            width: 0,
            height: 0,
            hideClippedValue: false,
            isValueContainedInElement: false,
        },
        seriesIdentifier: series_identifiers_1.MockSeriesIdentifier.default(),
        value: {
            accessor: 'y0',
            x: 0,
            y: 0,
            mark: null,
        },
        seriesStyle: barSeriesStyle,
    };
    return MockBarGeometry;
}());
exports.MockBarGeometry = MockBarGeometry;
var MockLineGeometry = (function () {
    function MockLineGeometry() {
    }
    MockLineGeometry.default = function (partial) {
        return commons_1.mergePartial(MockLineGeometry.base, partial, { mergeOptionalPartialValues: true });
    };
    MockLineGeometry.base = {
        line: '',
        points: [],
        color: color,
        transform: {
            x: 0,
            y: 0,
        },
        seriesIdentifier: series_identifiers_1.MockSeriesIdentifier.default(),
        seriesLineStyle: lineSeriesStyle.line,
        seriesPointStyle: lineSeriesStyle.point,
        clippedRanges: [],
    };
    return MockLineGeometry;
}());
exports.MockLineGeometry = MockLineGeometry;
var MockAreaGeometry = (function () {
    function MockAreaGeometry() {
    }
    MockAreaGeometry.default = function (partial) {
        return commons_1.mergePartial(MockAreaGeometry.base, partial, { mergeOptionalPartialValues: true });
    };
    MockAreaGeometry.base = {
        area: '',
        lines: [],
        points: [],
        color: color,
        transform: {
            x: 0,
            y: 0,
        },
        seriesIdentifier: series_identifiers_1.MockSeriesIdentifier.default(),
        seriesAreaStyle: areaSeriesStyle.area,
        seriesAreaLineStyle: areaSeriesStyle.line,
        seriesPointStyle: areaSeriesStyle.point,
        isStacked: false,
        clippedRanges: [],
    };
    return MockAreaGeometry;
}());
exports.MockAreaGeometry = MockAreaGeometry;
var MockBubbleGeometry = (function () {
    function MockBubbleGeometry() {
    }
    MockBubbleGeometry.default = function (partial) {
        return commons_1.mergePartial(MockBubbleGeometry.base, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockBubbleGeometry.base = {
        points: [],
        color: color,
        seriesIdentifier: series_identifiers_1.MockSeriesIdentifier.default(),
        seriesPointStyle: bubbleSeriesStyle.point,
    };
    return MockBubbleGeometry;
}());
exports.MockBubbleGeometry = MockBubbleGeometry;
//# sourceMappingURL=geometries.js.map