"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var commons_1 = require("../../utils/commons");
var data_1 = require("./data");
var utils_1 = require("../utils");
var rng = utils_1.getRandomNumberGenerator();
var MockDataSeries = (function () {
    function MockDataSeries() {
    }
    MockDataSeries.default = function (partial) {
        return commons_1.mergePartial(MockDataSeries.base, partial, { mergeOptionalPartialValues: true });
    };
    MockDataSeries.fitFunction = function (options) {
        if (options === void 0) { options = { shuffle: true, ordinal: false }; }
        var ordinalData = options.ordinal
            ? data_1.fitFunctionData.map(function (d) { return (__assign(__assign({}, d), { x: String.fromCharCode(97 + d.x) })); })
            : data_1.fitFunctionData;
        var data = options.shuffle && !options.ordinal ? lodash_1.shuffle(ordinalData) : ordinalData;
        return __assign(__assign({}, MockDataSeries.base), { data: data });
    };
    MockDataSeries.fromData = function (data) {
        return __assign(__assign({}, MockDataSeries.base), { data: data });
    };
    MockDataSeries.random = function (options, includeMarks) {
        if (includeMarks === void 0) { includeMarks = false; }
        var _a, _b;
        var data = new Array((_b = (_a = options) === null || _a === void 0 ? void 0 : _a.count, (_b !== null && _b !== void 0 ? _b : 10))).fill(0).map(function () { return MockDataSeriesDatum.random(options, includeMarks); });
        return __assign(__assign({}, MockDataSeries.base), { data: data });
    };
    MockDataSeries.base = {
        specId: 'spec1',
        seriesKeys: ['spec1'],
        yAccessor: 'y',
        splitAccessors: new Map(),
        key: 'spec1',
        data: [],
    };
    return MockDataSeries;
}());
exports.MockDataSeries = MockDataSeries;
var MockRawDataSeries = (function () {
    function MockRawDataSeries() {
    }
    MockRawDataSeries.default = function (_a) {
        var data = _a.data, partial = __rest(_a, ["data"]);
        return __assign(__assign(__assign({}, MockRawDataSeries.base), partial), (data && {
            data: data.map(function (datum) { return MockRawDataSeriesDatum.default(datum); }),
        }));
    };
    MockRawDataSeries.defaults = function (partials, defaults) {
        return partials.map(function (partial) {
            return MockRawDataSeries.default(__assign(__assign({}, defaults), partial));
        });
    };
    MockRawDataSeries.fitFunction = function (options) {
        if (options === void 0) { options = { shuffle: true, ordinal: false }; }
        var rawData = data_1.fitFunctionData.map(function (_a) {
            var initialY0 = _a.initialY0, initialY1 = _a.initialY1, filled = _a.filled, datum = __rest(_a, ["initialY0", "initialY1", "filled"]);
            return datum;
        });
        var ordinalData = options.ordinal
            ? rawData.map(function (d) { return (__assign(__assign({}, d), { x: String.fromCharCode(97 + d.x) })); })
            : rawData;
        var data = options.shuffle && !options.ordinal ? lodash_1.shuffle(ordinalData) : ordinalData;
        return __assign(__assign({}, MockRawDataSeries.base), { data: data });
    };
    MockRawDataSeries.fromData = function (data, defaults) {
        var mergedDefault = __assign(__assign({}, MockRawDataSeries.base), defaults);
        if (Array.isArray(data) && data[0] && Array.isArray(data[0])) {
            return data.map(function (d, i) { return (__assign(__assign({}, mergedDefault), { specId: "spec" + (i + 1), key: "key" + (i + 1), data: d.map(function (datum) { return MockRawDataSeriesDatum.default(datum); }) })); });
        }
        return __assign(__assign({}, mergedDefault), { data: [MockRawDataSeriesDatum.default(data)] });
    };
    MockRawDataSeries.base = {
        specId: 'spec1',
        seriesKeys: ['spec1'],
        yAccessor: 'y',
        splitAccessors: new Map(),
        key: 'spec1',
        data: [],
    };
    return MockRawDataSeries;
}());
exports.MockRawDataSeries = MockRawDataSeries;
var MockDataSeriesDatum = (function () {
    function MockDataSeriesDatum() {
    }
    MockDataSeriesDatum.default = function (partial) {
        return commons_1.mergePartial(MockDataSeriesDatum.base, partial, { mergeOptionalPartialValues: true });
    };
    MockDataSeriesDatum.simple = function (_a) {
        var x = _a.x, _b = _a.y1, y1 = _b === void 0 ? null : _b, _c = _a.y0, y0 = _c === void 0 ? null : _c, _d = _a.mark, mark = _d === void 0 ? null : _d, filled = _a.filled;
        return __assign({ x: x,
            y1: y1,
            y0: y0,
            mark: mark, initialY1: y1, initialY0: y0, datum: {
                x: x,
                y1: y1,
                y0: y0,
            } }, (filled && filled));
    };
    MockDataSeriesDatum.full = function (_a) {
        var _b = _a.fittingIndex, fittingIndex = _b === void 0 ? 0 : _b, datum = __rest(_a, ["fittingIndex"]);
        return __assign(__assign({}, MockDataSeriesDatum.simple(datum)), { fittingIndex: fittingIndex });
    };
    MockDataSeriesDatum.ordinal = function (partial) {
        return commons_1.mergePartial(__assign(__assign({}, MockDataSeriesDatum.base), { x: 'a' }), partial, { mergeOptionalPartialValues: true });
    };
    MockDataSeriesDatum.random = function (options, includeMark) {
        if (includeMark === void 0) { includeMark = false; }
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
        return MockDataSeriesDatum.simple(__assign({ x: rng((_b = (_a = options) === null || _a === void 0 ? void 0 : _a.x) === null || _b === void 0 ? void 0 : _b.min, (_d = (_c = options) === null || _c === void 0 ? void 0 : _c.x) === null || _d === void 0 ? void 0 : _d.max, (_e = options.x) === null || _e === void 0 ? void 0 : _e.fractionDigits, (_f = options.x) === null || _f === void 0 ? void 0 : _f.inclusive), y1: rng((_h = (_g = options) === null || _g === void 0 ? void 0 : _g.y) === null || _h === void 0 ? void 0 : _h.min, (_k = (_j = options) === null || _j === void 0 ? void 0 : _j.y) === null || _k === void 0 ? void 0 : _k.max, (_l = options.y) === null || _l === void 0 ? void 0 : _l.fractionDigits, (_m = options.y) === null || _m === void 0 ? void 0 : _m.inclusive) }, (includeMark && {
            mark: rng((_p = (_o = options) === null || _o === void 0 ? void 0 : _o.mark) === null || _p === void 0 ? void 0 : _p.min, (_r = (_q = options) === null || _q === void 0 ? void 0 : _q.mark) === null || _r === void 0 ? void 0 : _r.max, (_s = options.mark) === null || _s === void 0 ? void 0 : _s.fractionDigits, (_t = options.mark) === null || _t === void 0 ? void 0 : _t.inclusive),
        })));
    };
    MockDataSeriesDatum.base = {
        x: 1,
        y1: 1,
        y0: null,
        mark: null,
        initialY1: null,
        initialY0: 1,
        datum: null,
    };
    return MockDataSeriesDatum;
}());
exports.MockDataSeriesDatum = MockDataSeriesDatum;
var MockRawDataSeriesDatum = (function () {
    function MockRawDataSeriesDatum() {
    }
    MockRawDataSeriesDatum.default = function (partial) {
        return commons_1.mergePartial(MockRawDataSeriesDatum.base, partial);
    };
    MockRawDataSeriesDatum.simple = function (_a) {
        var x = _a.x, _b = _a.y1, y1 = _b === void 0 ? null : _b, _c = _a.y0, y0 = _c === void 0 ? null : _c;
        return {
            x: x,
            y1: y1,
            y0: y0,
            mark: null,
            datum: {
                x: 1,
                y1: 1,
                y0: 1,
            },
        };
    };
    MockRawDataSeriesDatum.ordinal = function (partial) {
        return commons_1.mergePartial(__assign(__assign({}, MockRawDataSeriesDatum.base), { x: 'a' }), partial);
    };
    MockRawDataSeriesDatum.base = {
        x: 1,
        y1: 1,
        y0: null,
        mark: null,
        datum: {
            x: 1,
            y1: 1,
            y0: 1,
        },
    };
    return MockRawDataSeriesDatum;
}());
exports.MockRawDataSeriesDatum = MockRawDataSeriesDatum;
//# sourceMappingURL=series.js.map