"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var commons_1 = require("../../utils/commons");
var specs_1 = require("../../chart_types/xy_chart/utils/specs");
var scales_1 = require("../../scales");
var chart_types_1 = require("../../chart_types");
var specs_2 = require("../../specs");
var light_theme_1 = require("../../utils/themes/light_theme");
var config_1 = require("../../chart_types/partition_chart/layout/config/config");
var group_by_rollup_1 = require("../../chart_types/partition_chart/layout/utils/group_by_rollup");
var config_types_1 = require("../../chart_types/partition_chart/layout/types/config_types");
var MockSeriesSpec = (function () {
    function MockSeriesSpec() {
    }
    MockSeriesSpec.bar = function (partial) {
        return commons_1.mergePartial(MockSeriesSpec.barBase, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockSeriesSpec.histogramBar = function (partial) {
        return commons_1.mergePartial(MockSeriesSpec.histogramBarBase, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockSeriesSpec.area = function (partial) {
        return commons_1.mergePartial(MockSeriesSpec.areaBase, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockSeriesSpec.line = function (partial) {
        return commons_1.mergePartial(MockSeriesSpec.lineBase, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockSeriesSpec.sunburst = function (partial) {
        return commons_1.mergePartial(MockSeriesSpec.sunburstBase, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockSeriesSpec.treemap = function (partial) {
        return commons_1.mergePartial(MockSeriesSpec.treemapBase, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockSeriesSpec.byType = function (type) {
        switch (type) {
            case specs_1.SeriesTypes.Line:
                return MockSeriesSpec.lineBase;
            case specs_1.SeriesTypes.Area:
                return MockSeriesSpec.areaBase;
            case specs_1.SeriesTypes.Bubble:
                return MockSeriesSpec.bubbleBase;
            case 'histogram':
                return MockSeriesSpec.histogramBarBase;
            case specs_1.SeriesTypes.Bar:
            default:
                return MockSeriesSpec.barBase;
        }
    };
    MockSeriesSpec.byTypePartial = function (type) {
        switch (type) {
            case 'line':
                return MockSeriesSpec.line;
            case 'area':
                return MockSeriesSpec.area;
            case 'histogram':
                return MockSeriesSpec.histogramBar;
            case 'bar':
            default:
                return MockSeriesSpec.bar;
        }
    };
    MockSeriesSpec.barBase = {
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        seriesType: specs_1.SeriesTypes.Bar,
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        xScaleType: scales_1.ScaleType.Ordinal,
        yScaleType: scales_1.ScaleType.Linear,
        xAccessor: 'x',
        yAccessors: ['y'],
        yScaleToDataExtent: false,
        hideInLegend: false,
        enableHistogramMode: false,
        stackAsPercentage: false,
        data: [],
    };
    MockSeriesSpec.histogramBarBase = {
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        seriesType: specs_1.SeriesTypes.Bar,
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        xScaleType: scales_1.ScaleType.Ordinal,
        yScaleType: scales_1.ScaleType.Linear,
        xAccessor: 'x',
        yAccessors: ['y'],
        yScaleToDataExtent: false,
        hideInLegend: false,
        enableHistogramMode: true,
        data: [],
    };
    MockSeriesSpec.areaBase = {
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        seriesType: specs_1.SeriesTypes.Area,
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        xScaleType: scales_1.ScaleType.Ordinal,
        yScaleType: scales_1.ScaleType.Linear,
        xAccessor: 'x',
        yAccessors: ['y'],
        yScaleToDataExtent: false,
        hideInLegend: false,
        histogramModeAlignment: specs_1.HistogramModeAlignments.Center,
        data: [],
    };
    MockSeriesSpec.lineBase = {
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        seriesType: specs_1.SeriesTypes.Line,
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        xScaleType: scales_1.ScaleType.Ordinal,
        yScaleType: scales_1.ScaleType.Linear,
        xAccessor: 'x',
        yAccessors: ['y'],
        yScaleToDataExtent: false,
        hideInLegend: false,
        histogramModeAlignment: specs_1.HistogramModeAlignments.Center,
        data: [],
    };
    MockSeriesSpec.bubbleBase = {
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        seriesType: specs_1.SeriesTypes.Bubble,
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        xScaleType: scales_1.ScaleType.Ordinal,
        yScaleType: scales_1.ScaleType.Linear,
        xAccessor: 'x',
        yAccessors: ['y'],
        yScaleToDataExtent: false,
        hideInLegend: false,
        data: [],
    };
    MockSeriesSpec.sunburstBase = {
        chartType: chart_types_1.ChartTypes.Partition,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        config: __assign(__assign({}, config_1.config), { partitionLayout: config_types_1.PartitionLayout.sunburst }),
        valueAccessor: function (d) { return (typeof d === 'number' ? d : 0); },
        valueGetter: function (n) { return n[group_by_rollup_1.AGGREGATE_KEY]; },
        valueFormatter: function (d) { return String(d); },
        percentFormatter: config_1.percentFormatter,
        topGroove: 0,
        layers: [
            {
                groupByRollup: function (d, i) { return i; },
                nodeLabel: function (d) { return String(d); },
                showAccessor: function () { return true; },
                fillLabel: {},
            },
        ],
        data: [],
    };
    MockSeriesSpec.treemapBase = {
        chartType: chart_types_1.ChartTypes.Partition,
        specType: specs_2.SpecTypes.Series,
        id: 'spec1',
        config: __assign(__assign({}, config_1.config), { partitionLayout: config_types_1.PartitionLayout.treemap }),
        valueAccessor: function (d) { return (typeof d === 'number' ? d : 0); },
        valueGetter: function (n) { return n[group_by_rollup_1.AGGREGATE_KEY]; },
        valueFormatter: function (d) { return String(d); },
        percentFormatter: config_1.percentFormatter,
        topGroove: 20,
        layers: [
            {
                groupByRollup: function (d, i) { return i; },
                nodeLabel: function (d) { return String(d); },
                showAccessor: function () { return true; },
                fillLabel: {},
            },
        ],
        data: [],
    };
    return MockSeriesSpec;
}());
exports.MockSeriesSpec = MockSeriesSpec;
var MockSeriesSpecs = (function () {
    function MockSeriesSpecs() {
    }
    MockSeriesSpecs.fromSpecs = function (specs) {
        return specs;
    };
    MockSeriesSpecs.fromPartialSpecs = function (specs) {
        return specs.map(function (_a) {
            var seriesType = _a.seriesType, spec = __rest(_a, ["seriesType"]);
            var base = MockSeriesSpec.byType(seriesType);
            return commons_1.mergePartial(base, spec, {
                mergeOptionalPartialValues: true,
            });
        });
    };
    MockSeriesSpecs.empty = function () {
        return [];
    };
    return MockSeriesSpecs;
}());
exports.MockSeriesSpecs = MockSeriesSpecs;
var MockGlobalSpec = (function () {
    function MockGlobalSpec() {
    }
    MockGlobalSpec.settings = function (partial) {
        return commons_1.mergePartial(MockGlobalSpec.settingsBase, partial, { mergeOptionalPartialValues: true });
    };
    MockGlobalSpec.settingsNoMargins = function (partial) {
        return commons_1.mergePartial(MockGlobalSpec.settingsBaseNoMargings, partial, {
            mergeOptionalPartialValues: true,
        });
    };
    MockGlobalSpec.axis = function (partial) {
        return commons_1.mergePartial(MockGlobalSpec.axisBase, partial, { mergeOptionalPartialValues: true });
    };
    MockGlobalSpec.settingsBase = {
        id: '__global__settings___',
        chartType: chart_types_1.ChartTypes.Global,
        specType: specs_2.SpecTypes.Settings,
        rendering: 'canvas',
        rotation: 0,
        animateData: true,
        showLegend: false,
        resizeDebounce: 10,
        debug: false,
        tooltip: {
            type: specs_2.TooltipType.VerticalCursor,
            snap: true,
        },
        legendPosition: commons_1.Position.Right,
        showLegendExtra: true,
        hideDuplicateAxes: false,
        theme: light_theme_1.LIGHT_THEME,
    };
    MockGlobalSpec.axisBase = {
        id: 'yAxis',
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Axis,
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        hide: false,
        showOverlappingTicks: false,
        showOverlappingLabels: false,
        position: commons_1.Position.Left,
        tickSize: 10,
        tickPadding: 10,
        tickFormat: function (tick) { return "" + tick; },
        tickLabelRotation: 0,
    };
    MockGlobalSpec.settingsBaseNoMargings = __assign(__assign({}, MockGlobalSpec.settingsBase), { theme: __assign(__assign({}, light_theme_1.LIGHT_THEME), { chartMargins: { top: 0, left: 0, right: 0, bottom: 0 }, chartPaddings: { top: 0, left: 0, right: 0, bottom: 0 }, scales: {
                barsPadding: 0,
                histogramPadding: 0,
            } }) });
    return MockGlobalSpec;
}());
exports.MockGlobalSpec = MockGlobalSpec;
var MockAnnotationSpec = (function () {
    function MockAnnotationSpec() {
    }
    MockAnnotationSpec.line = function (partial) {
        return commons_1.mergePartial(MockAnnotationSpec.lineBase, partial, { mergeOptionalPartialValues: true });
    };
    MockAnnotationSpec.rect = function (partial) {
        return commons_1.mergePartial(MockAnnotationSpec.rectBase, partial, { mergeOptionalPartialValues: true });
    };
    MockAnnotationSpec.lineBase = {
        id: 'line_annotation_1',
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Annotation,
        annotationType: specs_1.AnnotationTypes.Line,
        dataValues: [],
        domainType: specs_1.AnnotationDomainTypes.XDomain,
    };
    MockAnnotationSpec.rectBase = {
        id: 'rect_annotation_1',
        groupId: specs_1.DEFAULT_GLOBAL_ID,
        chartType: chart_types_1.ChartTypes.XYAxis,
        specType: specs_2.SpecTypes.Annotation,
        annotationType: specs_1.AnnotationTypes.Rectangle,
        dataValues: [],
    };
    return MockAnnotationSpec;
}());
exports.MockAnnotationSpec = MockAnnotationSpec;
//# sourceMappingURL=specs.js.map