"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chart_state_1 = require("../../state/chart_state");
var redux_1 = require("redux");
var specs_1 = require("../../state/actions/specs");
var chart_settings_1 = require("../../state/actions/chart_settings");
var MockStore = (function () {
    function MockStore() {
    }
    MockStore.default = function (_a, chartId) {
        var _b = _a === void 0 ? { width: 100, height: 100, top: 0, left: 0 } : _a, width = _b.width, height = _b.height, top = _b.top, left = _b.left;
        if (chartId === void 0) { chartId = 'chartId'; }
        var storeReducer = chart_state_1.chartStoreReducer(chartId);
        var store = redux_1.createStore(storeReducer);
        store.dispatch(chart_settings_1.updateParentDimensions({ width: width, height: height, top: top, left: left }));
        return store;
    };
    MockStore.addSpecs = function (specs, store) {
        store.dispatch(specs_1.specParsing());
        if (Array.isArray(specs)) {
            var actions = specs.map(specs_1.upsertSpec);
            actions.forEach(store.dispatch);
        }
        else {
            store.dispatch(specs_1.upsertSpec(specs));
        }
        store.dispatch(specs_1.specParsed());
    };
    MockStore.updateDimensions = function (_a, store) {
        var _b = _a === void 0 ? { width: 100, height: 100, top: 0, left: 0 } : _a, width = _b.width, height = _b.height, top = _b.top, left = _b.left;
        store.dispatch(chart_settings_1.updateParentDimensions({ width: width, height: height, top: top, left: left }));
    };
    return MockStore;
}());
exports.MockStore = MockStore;
//# sourceMappingURL=store.js.map