"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var seedrandom_1 = __importDefault(require("seedrandom"));
var data_generator_1 = require("../utils/data_generators/data_generator");
exports.forcedType = function (obj) {
    return obj;
};
exports.getRandomNumberGenerator = function (seed) {
    if (seed === void 0) { seed = process.env.RNG_SEED; }
    var rng = seedrandom_1.default(seed);
    return function randomNumberGenerator(min, max, fractionDigits, inclusive) {
        if (min === void 0) { min = 0; }
        if (max === void 0) { max = 1; }
        if (fractionDigits === void 0) { fractionDigits = 0; }
        if (inclusive === void 0) { inclusive = true; }
        var precision = Math.pow(10, Math.max(fractionDigits, 0));
        var scaledMax = max * precision;
        var scaledMin = min * precision;
        var offset = inclusive ? 1 : 0;
        var num = Math.floor(rng() * (scaledMax - scaledMin + offset)) + scaledMin;
        return num / precision;
    };
};
var SeededDataGenerator = (function (_super) {
    __extends(SeededDataGenerator, _super);
    function SeededDataGenerator(frequency) {
        if (frequency === void 0) { frequency = 500; }
        return _super.call(this, frequency, exports.getRandomNumberGenerator()) || this;
    }
    return SeededDataGenerator;
}(data_generator_1.DataGenerator));
exports.SeededDataGenerator = SeededDataGenerator;
//# sourceMappingURL=utils.js.map