"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _global = _interopRequireWildcard(require("global"));

var _addons = _interopRequireWildcard(require("@storybook/addons"));

var _ensureOptionsDefaults = _interopRequireDefault(require("./ensureOptionsDefaults"));

var _snapshotsTestsTemplate = _interopRequireDefault(require("./snapshotsTestsTemplate"));

var _integrityTestTemplate = _interopRequireDefault(require("./integrityTestTemplate"));

var _frameworkLoader = _interopRequireDefault(require("../frameworks/frameworkLoader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

_global.default.STORYBOOK_REACT_CLASSES = _global.default.STORYBOOK_REACT_CLASSES || {};
const methods = ['beforeAll', 'beforeEach', 'afterEach', 'afterAll'];

function callTestMethodGlobals(testMethod) {
  methods.forEach(method => {
    if (typeof testMethod[method] === 'function') {
      _global.default[method](testMethod[method]);
    }
  });
}

const isDisabled = parameter => parameter === false || parameter && parameter.disable === true;

function testStorySnapshots(options = {}) {
  if (typeof _global.describe !== 'function') {
    throw new Error('testStorySnapshots is intended only to be used inside jest');
  }

  _addons.default.setChannel((0, _addons.mockChannel)());

  const {
    storybook,
    framework,
    renderTree,
    renderShallowTree
  } = (0, _frameworkLoader.default)(options);
  const {
    asyncJest,
    suite,
    storyNameRegex,
    storyKindRegex,
    stories2snapsConverter,
    testMethod,
    integrityOptions,
    snapshotSerializers
  } = (0, _ensureOptionsDefaults.default)(options);
  const testMethodParams = {
    renderTree,
    renderShallowTree,
    stories2snapsConverter
  };
  const data = storybook.raw().filter(({
    name
  }) => storyNameRegex ? name.match(storyNameRegex) : true).filter(({
    kind
  }) => storyKindRegex ? kind.match(storyKindRegex) : true).reduce((acc, item) => {
    const {
      kind,
      storyFn: render,
      parameters
    } = item;
    const existing = acc.find(i => i.kind === kind);
    const {
      fileName
    } = item.parameters;

    if (!isDisabled(parameters.storyshots)) {
      if (existing) {
        existing.children.push(_objectSpread({}, item, {
          render,
          fileName
        }));
      } else {
        acc.push({
          kind,
          children: [_objectSpread({}, item, {
            render,
            fileName
          })]
        });
      }
    }

    return acc;
  }, []);

  if (data.length) {
    callTestMethodGlobals(testMethod);
    (0, _snapshotsTestsTemplate.default)({
      data,
      asyncJest,
      suite,
      framework,
      testMethod,
      testMethodParams,
      snapshotSerializers
    });
    (0, _integrityTestTemplate.default)(integrityOptions, stories2snapsConverter);
  } else {
    throw new Error('storyshots found 0 stories');
  }
}

var _default = testStorySnapshots;
exports.default = _default;