"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _glob = _interopRequireDefault(require("glob"));

var _global = require("global");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function integrityTest(integrityOptions, stories2snapsConverter) {
  if (integrityOptions === false) {
    return;
  }

  (0, _global.describe)('Storyshots Integrity', () => {
    (0, _global.it)('Abandoned Storyshots', () => {
      const snapshotExtension = stories2snapsConverter.getSnapshotExtension();

      const storyshots = _glob.default.sync(`**/*${snapshotExtension}`, integrityOptions);

      const abandonedStoryshots = storyshots.filter(fileName => {
        const possibleStoriesFiles = stories2snapsConverter.getPossibleStoriesFiles(fileName);
        return !possibleStoriesFiles.some(_fs.default.existsSync);
      });
      expect(abandonedStoryshots).toEqual([]);
    });
  });
}

var _default = integrityTest;
exports.default = _default;