"use strict";

require("core-js/modules/es.array.slice");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.freeze");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DocumentWrapper = void 0;

var _theming = require("@storybook/theming");

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n    /* Custom styles atop GitHub base theme (see below) */\n    font-size: ", "px;\n    line-height: 1.6;\n\n    h1 {\n      font-size: ", "px;\n      font-weight: ", ";\n    }\n\n    h2 {\n      font-size: ", "px;\n      border-bottom: 1px solid ", ";\n    }\n\n    h3 {\n      font-size: ", "px;\n    }\n\n    h4 {\n      font-size: ", "px;\n    }\n\n    h5 {\n      font-size: ", "px;\n    }\n\n    h6 {\n      font-size: ", "px;\n      color: ", ";\n    }\n\n    /* Custom for SB SyntaxHighlighter */\n\n    pre:not(.hljs) {\n      background: transparent;\n      border: none;\n      border-radius: 0;\n      padding: 0;\n      margin: 0;\n    }\n\n    pre pre,\n    pre.hljs {\n      padding: 15px;\n      margin: 0;\n\n      white-space: pre-wrap;\n      color: inherit;\n\n      font-size: 13px;\n      line-height: 19px;\n\n      code {\n        color: inherit;\n        font-size: inherit;\n      }\n    }\n\n    pre code {\n      margin: 0;\n      padding: 0;\n      white-space: pre;\n      border: none;\n      background: transparent;\n    }\n\n    pre code,\n    pre tt {\n      background-color: transparent;\n      border: none;\n    }\n\n    /* GitHub inspired Markdown styles loosely from https://gist.github.com/tuzz/3331384 */\n\n    body > *:first-of-type {\n      margin-top: 0 !important;\n    }\n\n    body > *:last-child {\n      margin-bottom: 0 !important;\n    }\n\n    a {\n      color: ", ";\n      text-decoration: none;\n    }\n\n    a.absent {\n      color: #cc0000;\n    }\n\n    a.anchor {\n      display: block;\n      padding-left: 30px;\n      margin-left: -30px;\n      cursor: pointer;\n      position: absolute;\n      top: 0;\n      left: 0;\n      bottom: 0;\n    }\n\n    h1,\n    h2,\n    h3,\n    h4,\n    h5,\n    h6 {\n      margin: 20px 0 10px;\n      padding: 0;\n      cursor: text;\n      position: relative;\n    }\n\n    h2:first-of-type,\n    h1:first-of-type,\n    h1:first-of-type + h2,\n    h3:first-of-type,\n    h4:first-of-type,\n    h5:first-of-type,\n    h6:first-of-type {\n      margin-top: 0;\n      padding-top: 0;\n    }\n\n    h1:hover a.anchor,\n    h2:hover a.anchor,\n    h3:hover a.anchor,\n    h4:hover a.anchor,\n    h5:hover a.anchor,\n    h6:hover a.anchor {\n      text-decoration: none;\n    }\n\n    h1 tt,\n    h1 code {\n      font-size: inherit;\n    }\n\n    h2 tt,\n    h2 code {\n      font-size: inherit;\n    }\n\n    h3 tt,\n    h3 code {\n      font-size: inherit;\n    }\n\n    h4 tt,\n    h4 code {\n      font-size: inherit;\n    }\n\n    h5 tt,\n    h5 code {\n      font-size: inherit;\n    }\n\n    h6 tt,\n    h6 code {\n      font-size: inherit;\n    }\n\n    p,\n    blockquote,\n    ul,\n    ol,\n    dl,\n    li,\n    table,\n    pre {\n      margin: 15px 0;\n    }\n\n    hr {\n      border: 0 none;\n      color: ", ";\n      height: 4px;\n      padding: 0;\n    }\n\n    body > h2:first-of-type {\n      margin-top: 0;\n      padding-top: 0;\n    }\n\n    body > h1:first-of-type {\n      margin-top: 0;\n      padding-top: 0;\n    }\n\n    body > h1:first-of-type + h2 {\n      margin-top: 0;\n      padding-top: 0;\n    }\n\n    body > h3:first-of-type,\n    body > h4:first-of-type,\n    body > h5:first-of-type,\n    body > h6:first-of-type {\n      margin-top: 0;\n      padding-top: 0;\n    }\n\n    a:first-of-type h1,\n    a:first-of-type h2,\n    a:first-of-type h3,\n    a:first-of-type h4,\n    a:first-of-type h5,\n    a:first-of-type h6 {\n      margin-top: 0;\n      padding-top: 0;\n    }\n\n    h1 p,\n    h2 p,\n    h3 p,\n    h4 p,\n    h5 p,\n    h6 p {\n      margin-top: 0;\n    }\n\n    li p.first {\n      display: inline-block;\n    }\n\n    ul,\n    ol {\n      padding-left: 30px;\n    }\n\n    ul :first-of-type,\n    ol :first-of-type {\n      margin-top: 0;\n    }\n\n    ul :last-child,\n    ol :last-child {\n      margin-bottom: 0;\n    }\n\n    dl {\n      padding: 0;\n    }\n\n    dl dt {\n      font-size: 14px;\n      font-weight: bold;\n      font-style: italic;\n      padding: 0;\n      margin: 15px 0 5px;\n    }\n\n    dl dt:first-of-type {\n      padding: 0;\n    }\n\n    dl dt > :first-of-type {\n      margin-top: 0;\n    }\n\n    dl dt > :last-child {\n      margin-bottom: 0;\n    }\n\n    dl dd {\n      margin: 0 0 15px;\n      padding: 0 15px;\n    }\n\n    dl dd > :first-of-type {\n      margin-top: 0;\n    }\n\n    dl dd > :last-child {\n      margin-bottom: 0;\n    }\n\n    blockquote {\n      border-left: 4px solid ", ";\n      padding: 0 15px;\n      color: ", ";\n    }\n\n    blockquote > :first-of-type {\n      margin-top: 0;\n    }\n\n    blockquote > :last-child {\n      margin-bottom: 0;\n    }\n\n    table {\n      padding: 0;\n      border-collapse: collapse;\n    }\n    table tr {\n      border-top: 1px solid ", ";\n      background-color: white;\n      margin: 0;\n      padding: 0;\n    }\n\n    table tr:nth-of-type(2n) {\n      background-color: ", ";\n    }\n\n    table tr th {\n      font-weight: bold;\n      border: 1px solid ", ";\n      text-align: left;\n      margin: 0;\n      padding: 6px 13px;\n    }\n\n    table tr td {\n      border: 1px solid ", ";\n      text-align: left;\n      margin: 0;\n      padding: 6px 13px;\n    }\n\n    table tr th :first-of-type,\n    table tr td :first-of-type {\n      margin-top: 0;\n    }\n\n    table tr th :last-child,\n    table tr td :last-child {\n      margin-bottom: 0;\n    }\n\n    img {\n      max-width: 100%;\n    }\n\n    span.frame {\n      display: block;\n      overflow: hidden;\n    }\n\n    span.frame > span {\n      border: 1px solid ", ";\n      display: block;\n      float: left;\n      overflow: hidden;\n      margin: 13px 0 0;\n      padding: 7px;\n      width: auto;\n    }\n\n    span.frame span img {\n      display: block;\n      float: left;\n    }\n\n    span.frame span span {\n      clear: both;\n      color: ", ";\n      display: block;\n      padding: 5px 0 0;\n    }\n\n    span.align-center {\n      display: block;\n      overflow: hidden;\n      clear: both;\n    }\n\n    span.align-center > span {\n      display: block;\n      overflow: hidden;\n      margin: 13px auto 0;\n      text-align: center;\n    }\n\n    span.align-center span img {\n      margin: 0 auto;\n      text-align: center;\n    }\n\n    span.align-right {\n      display: block;\n      overflow: hidden;\n      clear: both;\n    }\n\n    span.align-right > span {\n      display: block;\n      overflow: hidden;\n      margin: 13px 0 0;\n      text-align: right;\n    }\n\n    span.align-right span img {\n      margin: 0;\n      text-align: right;\n    }\n\n    span.float-left {\n      display: block;\n      margin-right: 13px;\n      overflow: hidden;\n      float: left;\n    }\n\n    span.float-left span {\n      margin: 13px 0 0;\n    }\n\n    span.float-right {\n      display: block;\n      margin-left: 13px;\n      overflow: hidden;\n      float: right;\n    }\n\n    span.float-right > span {\n      display: block;\n      overflow: hidden;\n      margin: 13px auto 0;\n      text-align: right;\n    }\n\n    code,\n    tt {\n      margin: 0 2px;\n      padding: 0 5px;\n      white-space: nowrap;\n      border: 1px solid ", ";\n      background-color: ", ";\n      border-radius: 3px;\n      color: ", ";\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var DocumentWrapper = _theming.styled.div(function (_ref) {
  var theme = _ref.theme;
  return (0, _theming.css)(_templateObject(), theme.typography.size.s2, theme.typography.size.l1, theme.typography.weight.black, theme.typography.size.m2, theme.appBorderColor, theme.typography.size.m1, theme.typography.size.s3, theme.typography.size.s2, theme.typography.size.s2, theme.color.dark, theme.color.secondary, theme.appBorderColor, theme.color.medium, theme.color.dark, theme.appBorderColor, theme.color.lighter, theme.appBorderColor, theme.appBorderColor, theme.color.medium, theme.color.darkest, theme.color.mediumlight, theme.color.lighter, theme.base === 'dark' && theme.color.darkest);
});

exports.DocumentWrapper = DocumentWrapper;